//+------------------------------------------------------------------
//| original by Metatrader4 Code by jjk2.                            
//| modified by mladen
//+------------------------------------------------------------------
#property copyright "Based on MBA Thesis from Simon Fraser University written by C.E. ALDEA."
#property link      ""
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 PaleVioletRed
#property indicator_color3 PaleVioletRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern ENUM_TIMEFRAMES TimeFrame    = PERIOD_CURRENT;
extern int             Kperiod      = 32;
extern int             Dperiod      = 6;
extern int             slowing      = 9;
extern ENUM_MA_METHOD  method_stoch = MODE_SMA;
extern ENUM_STO_PRICE  price_field  = 1;
extern int             mode         = 0;
extern int             period_rsi   = 9;
extern int             period_momentum = 9;
extern int             smoothPeriod = 10;
extern ENUM_MA_METHOD  smoothMethod = MODE_SMA;


extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

double kwan[];
double kwanDa[];
double kwanDb[];
double temp[];
double slope[];

string indicatorFileName;
bool   returnBars;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,kwan);
   SetIndexBuffer(1,kwanDa);
   SetIndexBuffer(2,kwanDb);
   SetIndexBuffer(3,temp);
   SetIndexBuffer(4,slope);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
      
   IndicatorShortName(timeFrameToString(TimeFrame)+" kwan (+"+Kperiod+","+Dperiod+","+slowing+")");
   return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { kwan[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      if (slope[limit]==-1) CleanPoint(limit,kwanDa,kwanDb);
      for (i=limit; i>= 0; i--)
      {
         double Stoch  = iStochastic(NULL,0,Kperiod,Dperiod,slowing,method_stoch,price_field,mode,i);
         double RSI    = iRSI(NULL,0,period_rsi,PRICE_CLOSE,i);
         double moment = iMomentum(NULL,0,period_momentum,PRICE_CLOSE,i);
         if (moment!=0)
               temp[i] = Stoch*RSI/moment;
         else  temp[i] = 0;       
      }
      for (i=limit; i>= 0; i--)
      {
         kwanDa[i] = EMPTY_VALUE;
         kwanDb[i] = EMPTY_VALUE;
         kwan[i]   = iMAOnArray(temp,0,smoothPeriod,0,smoothMethod,i);
         slope[i]  = slope[i+1];
            if (kwan[i] > kwan[i+1]) slope[i] =  1;
            if (kwan[i] < kwan[i+1]) slope[i] = -1;
            if (slope[i]==-1) PlotPoint(i,kwanDa,kwanDb,kwan);
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
         
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (slope[limit]==-1) CleanPoint(limit,kwanDa,kwanDb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         slope[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Kperiod,Dperiod,slowing,method_stoch,price_field,mode,period_rsi,period_momentum,smoothPeriod,smoothMethod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
         kwan[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Kperiod,Dperiod,slowing,method_stoch,price_field,mode,period_rsi,period_momentum,smoothPeriod,smoothMethod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
         kwanDa[i] = EMPTY_VALUE;
         kwanDb[i] = EMPTY_VALUE;
            if (slope[i]==-1) PlotPoint(i,kwanDa,kwanDb,kwan);
   }
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar=0;
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] ==  1) doAlert("up"  );
         if (slope[whichBar] == -1) doAlert("down");
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Kwan changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" Kwan",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i];  first[i+1]  = from[i+1];  second[i] = EMPTY_VALUE; }
         else  { second[i] =  from[i]; second[i+1] =  from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                            second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}